def config

def GetDeploymentConfiguration(String branch) {
    def split = branch.split("/")
      def appName = split[1];
      def clientName = split[2];
      def environment = split[3];

      def environmentHumanized = '';

      def environmentArray = environment.split('-');

      if (environmentArray.length == 0) {
            environmentHumanized = environment.capitalize();
      }


      for(int i = 0; i < environmentArray.size(); i++) {
        def word = environmentArray[i];
        def firstLetter = word.substring(0, 1);
        def restOfWord = word.substring(1, word.length());
        def capitalizedWord = firstLetter.toUpperCase() + restOfWord;
        environmentHumanized += capitalizedWord;
      }

    def config = readJSON(file: "${env.WORKSPACE}/settings-config.json")
    def config = [:]

    // e.g. rcms
    config['appName'] = appName

    // e.g. cabs
    config['clientName'] = clientName

    // e.g. dev, test or live
    config['environment'] = config.environments[environment],

    // e.g. http://0:0:0:0:0000
    config['proxyPass'] = config.apps[appName][clientName][environment].proxyPass.replaceAll('/', '\\\\$0')

    // e.g. cabsDevelop
    config['ngBuildConfiguration'] = clientName + environmentHumanized

    // kubernetes namespace e.g. develop, single-repo-rcms-test, live
    config['namespace'] = config.namespaces[environment]

    return config
}

properties([gitLabConnection('gitlab-api-token-2fa')])

pipeline {
  agent any
  tools {
      nodejs 'Nodev16.3.2'
  }
  stages {
      stage('Init') {
        steps {
          script {
            config = GetDeploymentConfiguration(env.BRANCH_NAME);

            sh "echo ${config}"
          }
        }
      }
  }
  stage("Node Install Packages") {
      steps {
        sh "npm install -g yarn"
        sh "yarn --immutable --immutable-cache --check-cache"
        //// sh "yarn"
      }
  }
}
